# Class VulkanPresentInfoKHR.Builder

java.lang.Object
com.io7m.jcoronado.extensions.khr_swapchain.api.VulkanPresentInfoKHR.Builder

Enclosing class:
  `VulkanPresentInfoKHR`

public static final class VulkanPresentInfoKHR.Builder extends Object
Builds instances of type `VulkanPresentInfoKHR`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `final VulkanPresentInfoKHR.Builder`
  `addAllImageIndices(Iterable<Integer> elements)`
  Adds elements to `imageIndices` list.
  `final VulkanPresentInfoKHR.Builder`
  `addAllSwapChains(Iterable<? extends VulkanExtKHRSwapChainType.VulkanKHRSwapChainType> elements)`
  Adds elements to `swapChains` list.
  `final VulkanPresentInfoKHR.Builder`
  `addAllWaitSemaphores(Iterable<? extends VulkanSemaphoreType> elements)`
  Adds elements to `waitSemaphores` list.
  `final VulkanPresentInfoKHR.Builder`
  `addImageIndices(int element)`
  Adds one element to `imageIndices` list.
  `final VulkanPresentInfoKHR.Builder`
  `addImageIndices(int... elements)`
  Adds elements to `imageIndices` list.
  `final VulkanPresentInfoKHR.Builder`
  `addSwapChains(VulkanExtKHRSwapChainType.VulkanKHRSwapChainType element)`
  Adds one element to `swapChains` list.
  `final VulkanPresentInfoKHR.Builder`
  `addSwapChains(VulkanExtKHRSwapChainType.VulkanKHRSwapChainType... elements)`
  Adds elements to `swapChains` list.
  `final VulkanPresentInfoKHR.Builder`
  `addWaitSemaphores(VulkanSemaphoreType element)`
  Adds one element to `waitSemaphores` list.
  `final VulkanPresentInfoKHR.Builder`
  `addWaitSemaphores(VulkanSemaphoreType... elements)`
  Adds elements to `waitSemaphores` list.
  `VulkanPresentInfoKHR`
  `build()`
  Builds a new `VulkanPresentInfoKHR`.
  `final VulkanPresentInfoKHR.Builder`
  `from(VulkanPresentInfoKHRType instance)`
  Fill a builder with attribute values from the provided `VulkanPresentInfoKHRType` instance.
  `final VulkanPresentInfoKHR.Builder`
  `setImageIndices(Iterable<Integer> elements)`
  Sets or replaces all elements for `imageIndices` list.
  `final VulkanPresentInfoKHR.Builder`
  `setSwapChains(Iterable<? extends VulkanExtKHRSwapChainType.VulkanKHRSwapChainType> elements)`
  Sets or replaces all elements for `swapChains` list.
  `final VulkanPresentInfoKHR.Builder`
  `setWaitSemaphores(Iterable<? extends VulkanSemaphoreType> elements)`
  Sets or replaces all elements for `waitSemaphores` list.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final VulkanPresentInfoKHR.Builder from(VulkanPresentInfoKHRType instance)
    Fill a builder with attribute values from the provided `VulkanPresentInfoKHRType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values. Collection elements and entries will be added, not replaced.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### addWaitSemaphores

    public final VulkanPresentInfoKHR.Builder addWaitSemaphores(VulkanSemaphoreType element)
    Adds one element to `waitSemaphores` list.
    Parameters:
      `element` - A waitSemaphores element
    Returns:
      `this` builder for use in a chained invocation

  - ### addWaitSemaphores

    public final VulkanPresentInfoKHR.Builder addWaitSemaphores(VulkanSemaphoreType... elements)
    Adds elements to `waitSemaphores` list.
    Parameters:
      `elements` - An array of waitSemaphores elements
    Returns:
      `this` builder for use in a chained invocation

  - ### setWaitSemaphores

    public final VulkanPresentInfoKHR.Builder setWaitSemaphores(Iterable<? extends VulkanSemaphoreType> elements)
    Sets or replaces all elements for `waitSemaphores` list.
    Parameters:
      `elements` - An iterable of waitSemaphores elements
    Returns:
      `this` builder for use in a chained invocation

  - ### addAllWaitSemaphores

    public final VulkanPresentInfoKHR.Builder addAllWaitSemaphores(Iterable<? extends VulkanSemaphoreType> elements)
    Adds elements to `waitSemaphores` list.
    Parameters:
      `elements` - An iterable of waitSemaphores elements
    Returns:
      `this` builder for use in a chained invocation

  - ### addSwapChains

    public final VulkanPresentInfoKHR.Builder addSwapChains(VulkanExtKHRSwapChainType.VulkanKHRSwapChainType element)
    Adds one element to `swapChains` list.
    Parameters:
      `element` - A swapChains element
    Returns:
      `this` builder for use in a chained invocation

  - ### addSwapChains

    public final VulkanPresentInfoKHR.Builder addSwapChains(VulkanExtKHRSwapChainType.VulkanKHRSwapChainType... elements)
    Adds elements to `swapChains` list.
    Parameters:
      `elements` - An array of swapChains elements
    Returns:
      `this` builder for use in a chained invocation

  - ### setSwapChains

    public final VulkanPresentInfoKHR.Builder setSwapChains(Iterable<? extends VulkanExtKHRSwapChainType.VulkanKHRSwapChainType> elements)
    Sets or replaces all elements for `swapChains` list.
    Parameters:
      `elements` - An iterable of swapChains elements
    Returns:
      `this` builder for use in a chained invocation

  - ### addAllSwapChains

    public final VulkanPresentInfoKHR.Builder addAllSwapChains(Iterable<? extends VulkanExtKHRSwapChainType.VulkanKHRSwapChainType> elements)
    Adds elements to `swapChains` list.
    Parameters:
      `elements` - An iterable of swapChains elements
    Returns:
      `this` builder for use in a chained invocation

  - ### addImageIndices

    public final VulkanPresentInfoKHR.Builder addImageIndices(int element)
    Adds one element to `imageIndices` list.
    Parameters:
      `element` - A imageIndices element
    Returns:
      `this` builder for use in a chained invocation

  - ### addImageIndices

    public final VulkanPresentInfoKHR.Builder addImageIndices(int... elements)
    Adds elements to `imageIndices` list.
    Parameters:
      `elements` - An array of imageIndices elements
    Returns:
      `this` builder for use in a chained invocation

  - ### setImageIndices

    public final VulkanPresentInfoKHR.Builder setImageIndices(Iterable<Integer> elements)
    Sets or replaces all elements for `imageIndices` list.
    Parameters:
      `elements` - An iterable of imageIndices elements
    Returns:
      `this` builder for use in a chained invocation

  - ### addAllImageIndices

    public final VulkanPresentInfoKHR.Builder addAllImageIndices(Iterable<Integer> elements)
    Adds elements to `imageIndices` list.
    Parameters:
      `elements` - An iterable of imageIndices elements
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public VulkanPresentInfoKHR build()
    Builds a new `VulkanPresentInfoKHR`.
    Returns:
      An immutable instance of VulkanPresentInfoKHR
    Throws:
      `IllegalStateException` - if any required attributes are missing